  .include "../symbols_boot.s"
  .org $3000

; Vector definitions
  .byte $AA
  .byte $55           ; Init bytes
  .word entry_point
  .word irq
  .word nmi

entry_point:
  ; Initialize stack pointer
  ldx #$FF
  txs

  ; Enable interrupts
  cli

  ; Init pstack
  jsr pstack_init

  ; Clear VGA display
  lda #0
  jsr vga_clear_display

  ; Print hello message
  ldx #<welcome_mesage
  ldy #>welcome_mesage
  jsr vga_print_string

  stz PS2_MODIFIERS

  ; 0.75
  ldx #$00
  ldy #($3A | $0)
  jsr pstack_push

  ; ; 13.75
  ; ldx #$A0
  ; ldy #$4A
  ; jsr pstack_push

  ; 0.25
  ldx #$00
  ldy #($34 | $0)
  jsr pstack_push

  jsr float_add
  ; Result on pStack

  ; 0.75
  ldx #$00
  ldy #($3A | $0)
  jsr pstack_push

  ; ; 13.75
  ; ldx #$A0
  ; ldy #$4A
  ; jsr pstack_push

  ; 0.25
  ldx #$00
  ldy #($34 | $0)
  jsr pstack_push

  ldx #<str_1
  ldy #>str_1
  jsr printf
  jsr vga_print_string


  ; Initialize new line with prompt
  jsr shell_init_line


.program_loop:
;   jsr uart_recv         ; Wait for programming request

;   cmp #'b'
;   beq .bootload         ; On 'b' branch to bootload

;   jmp .end

; .bootload:
;   jmp $8000

.end:
  jmp .program_loop

string_done .asciiz "Init done!"
welcome_mesage .asciiz "6502 boot successful.\r\nWaiting for instructions...\r\n\n"
; str_1 .asciiz "hex8 = 0x%x\r\n"
str_1 .asciiz "%f + %f = %f\r\n"

; ---------------------------------------------------------------------------------------------------------
; Interrupts

irq:
  rti

nmi:
  rti

; Includes
  .include "shell.s"
  .include "../variables.s"