; ------------------------------------------------------------
; Delay routines for 6502 computer

delay_x:
  ; Delays program's execution by
  ; delay_a + X * delay_a (A = 255)
  ;
  ; PARAMETERS
  ; X - delay_a repetitions

  jsr delay_a

.loop:
  lda #$FF
  jsr delay_a

  dex
  bne .loop

  rts


delay_a:
  ; Delays execution of the program by
  ; 21*A + 12 cycles
  ;
  ; PARAMETERS
  ; A - delay time
  ;
  ; Overhead
  ;     jsr -  6 cycles
  ;     rts -  6 cycles
  ; Overhead: 12 cycles

  jsr delay_16    ; 16 cycles
  dea             ;  2 cycles
  bne delay_a     ;  3 cycles
  ;               ; 21 cycles

  rts


delay_16:
  ; Delays program execution by 16 cycles
  
  ;    jsr -  6 cycles
  ;    rts -  6 cycles
  ; 2x nop -  4 cycles
  ;          16 cycles
  nop
  nop

  rts