; ---------------------------------------------------------------------------------------------------------
; 6502 library for handling hexadecimal numbers

sprint_hex:
  ; Converts A-byte number to it's hexadecimal representation.
  ;
  ; PARAMETERS
  ; A - byte number
  ; X - low byte of the number,
  ; Y - high byte of the number,
  ;
  ; RETURNS
  ; Decimal representation at STRING_ADDRESS - No null termination.

  ; A is 1/2
  asl                   ; A is 2/4
  sta HEX_BYTE_COUNT    ; Save nibble count

  cmp #4
  beq .skip             ; If 16-bit, skip
  ; If 8-bit swap X -> Y (saved first)
  txa
  tay

.skip:
  sty HEX_NUMBER+0
  stx HEX_NUMBER+1

  ldx #0
.loop:

  ldy #0
.roll_loop:
  rol HEX_NUMBER+1
  rol HEX_NUMBER+0
  rol A                 ; Roll bits into accumulator

  iny
  cpy #4
  bne .roll_loop
  ; End loop

  and #$0F              ; Take low 4 bytes
  tay                   ; Save index in Y
  lda .charset, y       ; Load character into A
  sta (STRING_ADDRESS)

  inc STRING_ADDRESS
  bne .no_carry
  inc STRING_ADDRESS+1
.no_carry:

  inx
  cpx HEX_BYTE_COUNT
  bne .loop
  ; End loop

  rts

.charset: .ascii "0123456789ABCDEF"