#!/usr/bin/env python

import sys, re
sys.path.append("/")

regex = re.compile("(.*): symbol: (\S+)")
exclude = ["reset", "program_loop", "write_page", "read_page", "init_string", "no_app_string", "charset", "uart_init", "a_eq", "x_eq", "y_eq", "lcd_init", "lcd_wait_busy", "lcd_write_data", "irq", "nmi"]

if len(sys.argv) != 2:
    print(f"Usage: {sys.argv[0]} [name of file].test")
    
name = sys.argv[1]

symbols = open(f"/home/norbert/6502/asm/src/symbols_{name}.s", "w")
# symbols = open("symbols.s", "w")

for line in open(f"/home/norbert/6502/asm/build/{name}.test"):
    line = line.strip()
    matches = regex.match(line)

    if matches is not None:
        # print(line)
        # print(matches.groups())
        [address, name] = matches.groups()

        if name in exclude:
            continue

        # Exclude generation
        # print("\"{}\"".format(name), end=", ")

        symbols.write("{} = ${}\n".format(name, address.upper()))

symbols.close()
